// convert.cpp - convert between members of Waveform classes
//
// C++ (c) 1996 Mark Huckvale University College London

#include "signal.h"
#include "waveform.h"
#include "compwave.h"
#include "convert.h"

Waveform SignalToWaveform(const Signal& s)
{
	Waveform w = s.toWaveDouble();
	return w;
}

Signal WaveformToSignal(const Waveform& w)
{
	Signal s = w.toWaveShort();
	return s;
}

ComplexWaveform WaveformToComplexWaveform(const Waveform& w)
{
	ComplexWaveform c = w.toWaveComplex();
	return c;
}

Waveform ComplexWaveformMagToWaveform(const ComplexWaveform& c)
{
	Waveform w = c.magtoWaveDouble();
	return w;
}

Waveform ComplexWaveformRealToWaveform(const ComplexWaveform& c)
{
	Waveform w = c.realtoWaveDouble();
	return w;
}

